
#define Version "150428"

//#define Test1

// rajout lecture ADC EA3 pin 2 (RA3)
// centrage  droite resultat Volt en flottant avec 3 decimales
// sortie UART

// documentation
//ac:Pinout_16F1847
 //ac:Datasheet_16F1847
//projet  :16F1847_LCD_I2C.mcppi
//source : C:\_MikroC\_MesProjets_MikroC\_16F1847_LCD_I2C\16F1847_LCD4x20_I2C_ADC_UART.c
//Results compliation : Compilation.txt

/*
Hardware:
16F1847  DIP18
PIN 1    RA2/AN2 DACOUT
PIN 2    RA3 AN3  <--- analog input  0 - 5V
PIN 3    RA4/AN4  output --> Led-1K--+5V
                    |-----750----------ICSP VPP  PIN 1
Pin 4     RA5/ MCLR |--- 6,2K --- +5V
Pin 5     VSS et ----------------------ICSP Gnd Pin 3
pin 7     RB1 SDA1 ------------I2C bus  ----2,7K --+5V
pin 8     RB2 TX UART -------> interface 2Tr -> PC COM
pin 9     RB3/AN9/ CCP1/P1A
-----
Pin 18    RA1/AN1
Pin 17    RA0/AN0
Pin 16    RA7/OSC1/ClockIn
Pin 15    RA6/OSC2/ClockOut
pin 14    VDD +5V 
pin 13    RB7/AN6--- 750 ------------- ICSPDAT   Pin 4
pin 12    RB6/AN5--- 750 --------------- ICSPCLCK Pin 5
pin 11    RB5/AN5
pin 10    RB4 SCL1 -----------I2C BUS ---2,7K --- +5V

FOSC interne 8 MHz
CONFIG1 : $8007 : 0x39E4
CONFIG2 : $8008 : 0x1613

*/

// 18 aout 2014  usage my_new Library  LCD_I2C

#define p16f1847
#include "built_in.h"     // for  Hi  Lo ..etc
#include "Lib_LCD_I2C.h"
#include "Delays.h"


#define POWER_SUPPLY  DC_5V
#define XTAL_FREQ 8    //MHZ
#define FOSC 8.0  // MHz
#define CLS 12
#define CR 13
#define LF 10
#define TAB 9
#define BACK 8
#define Beep 7
#define Separator 0x20   // space

// **********  Config Hardware **********************
//#define LCD_ADDR 0x27   //  PCF85741
#define LCD_ADDR 0x4E     // PCF8574 on pigboard YwRobot back located  on LCD4x20
// PCF8574 I2C LCD Port Definition
// P7,P6,P5,P4 = Data, P3=Backlight (BL), P2=E, P1=RW, P0=RS
#define LCD_BL 0x08
#define LCD_EN 0x04
#define LCD_RW 0x02
#define LCD_RS 0x01

// ref : ODT OCM-20416D-A2023 LCD Module  8/4/1999
// LCD Command
#define LCD_CLEAR 0x01
#define LCD_HOME  0x02
#define Display_ON 0x0C
#define Display_OFF 0x08
#define LCD_LINE1 0x80      // 0x00 + bit D7=1
#define LCD_LINE2 0xC0      // 0x40 + bit D7=1
#define LCD_LINE3 0x94      // 0x14 + bit D7=1
#define LCD_LINE4 0xD4      // 0x54 + bit D7=1

// ********************************************

sbit Led_Rouge at LATA4_bit;

const code char mesg0[]="                   "; // pour effacer la ligne LCD
const code char mesg1[]="Mikroc pro 6.50, Test LCD4x20 I2C 16F1847 Version: "Version" \n\r";
const code char * Messages[]={mesg0,mesg1};

// *********************

unsigned  char TEXTE[80]; // needed also by pointer txt !
int i,j,k,l;
unsigned int EA1,EA2,EA3;
unsigned char * txt;
char CRam1[20];

int Etat;
int addr;
float f1;

void Read_Msg_Eeprom(unsigned char depuis);
void Init_Hardware(void);
void Float2Ascii (float x, unsigned char *str,char precision);
void CRLF(void);
void UART1_Write_CText(const char *txt);

//void strConstRamCpy(unsigned char *dest, const code char *source);
void Init_Hardware(void) ;

/* --- Copie le texte depuis FLASH ROM vers RAM
void strConstRamCpy(unsigned char *dest, const code char *source)
 {
  while (*source)*dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}
*/

void Init_Hardware()
{
  ANSELA=0; 
  TRISA=0xFF;
 // TRISA.LATA4_bit=0;
  TRISA.LATA4=0;
  ANSELA.F3=1;

  ANSELB = 0xFF;
  PORTB = 0xFF;
  TRISB = 0x00;    // Portb output

 CM1CON0=0;       // disable comparators
 CM1CON1=0;
  
  TRISB.TRISB1 = 1;  // SDA1 I2C
  TRISB.TRISB4 = 1;  // SCL1 I2C
 }


void Float2Ascii (float x, unsigned char *str,char precision)
{
 /* converts a floating point number to an ascii string */
 /* x is stored into str, which should be at least 30 chars long */
 unsigned char *adpt;
 int ie, i, k, ndig;
 double y;
 ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
 ie = 0;
 /* if x negative, write minus and reverse */
 if ( x < 0)
 {
   *str++ = '-';
   x = -x;
 }
 /* put x in range 1 <= x < 10 */
 if (x > 0.0) while (x < 1.0)
 {
   x *= 10.0;                // a la place de =*
   ie--;
 }
 while (x >= 10.0)
 {
   x = x/10.0;
   ie++;
 }
 // in f format, number of digits is related to size
 ndig += ie;                                // a la place de =+
 //round. x is between 1 and 10 and ndig will be printed to
 // right of decimal point so rounding is ...
 for (y = i = 1; i < ndig; i++)
 y = y/10.;
 x += y/2.;
 if (x >= 10.0) {x = 1.0; ie++;}
 if (ie<0)
 {
   *str++ = '0'; *str++ = '.';
   if (ndig < 0) ie = ie-ndig;
   for (i = -1; i > ie; i--)  *str++ = '0';
 }
 for (i=0; i < ndig; i++)
 {
   k = x;
   *str++ = k + '0';
   if (i ==  ie ) *str++ = '.';
   x -= (y=k);
   x *= 10.0;
  }
 *str = '\0';
}

void CRLF()
{
 UART1_Write(CR);
 UART1_Write(LF);
}


void UART1_Write_CText(const char *txt) {
   while (*txt)
      UART1_Write(*txt++);
}


void Read_Msg_Eeprom(unsigned char debut)
{   int i1 ,i;
  i1=debut;
  do
  {
  i = EEPROM_Read(i1);
  if ( i==0) break;
  if ( i1>254) break;
  UART1_Write(i);
  Delay_ms(5);
  i1++;
   }
  while (i!=0) ;
 }

void main()
 {
  // Internal FOSC is 500Khz by default !
  OSCCON =0;        // PLL disbled
  OSCCON.IRCF3=1;         //8 MHz
  OSCCON.IRCF2=1;
  OSCCON.IRCF1=1;
  OSCCON.IRCF0=0;
  OSCCON.SCS1=1;  // internal FOSC

  Init_Hardware() ;
  
  txt=TEXTE; // init pointeur
  
  APFCON1.TXCKSEL=0; //  TX/CK function is on RB2
  UART1_Init(9600);
  UART1_Write(CLS);
  Tempo_XmS(500);
  UART1_Write_CText(mesg1);
  Read_Msg_Eeprom(0);
  CRLF();

  ADC_Init();
  Tempo_XmS(100);
  UART1_Write_CText("Init ADC RA3 pin2 as Analog input\r\n");
  j=0;
  
  
   ADCON0 =0;

    
   ADCON1 = 0;

   ADCON1.ADFM=1; // Right justified
   ADCON1.ADCS2=1;   //  101 = FOSC/16
   ADCON1.ADCS1=0;
   ADCON1.ADCS0=1;
   ADCON1.ADNREF=0; //VREF- is connected to VSS
   ADCON1.ADPREF1=0; //VREF+ is connected to VDD
   ADCON1.ADPREF0=0; //00= VREF+ is connected to VDD
  
   ADCON0.CHS4=0;  //00011 = AN3  Chanel select
   ADCON0.CHS3=0;
   ADCON0.CHS2=0;
   ADCON0.CHS1=1;
   ADCON0.CHS0=1;
   ADCON0.ADON=1; //Enable A/D module
   // no ADCON2 on 16F1847

 // --- test particulier : mesure sur 8 bits
  #ifdef Test1
  ADCON1.ADFM=0; // left justified
  k=0;
  while(k<255)
  {
   ADCON0.GO_NOT_DONE=1;  //Start A/D Conversion
   while( ADCON0.GO_NOT_DONE!= 0);//Loop here until A/D conversion completes
   k = ADRESH;//Set the delay to the 8 MSB
   Led_Rouge = ~Led_Rouge;//Toggle LED Pin
   if (k > 0) Tempo_XmS(k);
   UART1_Write_CText("ADC= ");
   WordToStr(k,txt);
   UART1_Write_Text(txt);
   CRLF();
   };
  #endif

  I2C1_Init(400000);
  do
  {
  // adrr= adresse du PCF8754 du LCD4x20
  addr=LCD_ADDR;
  LCD_init_4x20();
  LCD_putcmd(LCD_CLEAR,1);  // LCD Clear
  LCD_putcmd(LCD_LINE1,1);  Delay_ms(25);  // sans ce delai ,les 3 premiers caracteres sont bouffes sur le LCD
  LCD_putsRom((const code unsigned char *)"16F1847 8MHz MikroC ");
  LCD_putcmd(LCD_LINE2,1); Delay_ms(25);
  LCD_putsRom((const code unsigned char *)"Test library LCD I2C");
  LCD_putcmd(LCD_LINE3,1); Delay_ms(25);
  LCD_putsRom((const code unsigned char *)"version:" Version);
   Tempo_XmS(500);
  do
   {
   LCD_putcmd(LCD_LINE4,1); Delay_ms(25);
   EA3=ADC_Get_Sample(3);
   WordToStr(EA3,txt);
   LCD_puts(txt);
   f1= (float) EA3 * 0.0048828; //  5.00/1024.0   Float2Ascii (f1,CRam1,3);
   Float2Ascii (f1,CRam1,3);
   k=10-strlen(CRam1);
   LCD_putcmd(LCD_LINE4+10,1);Delay_ms(25);
   // Right alignement from position 10
   while(k>0) 
   {
     LCD_putch(32); // Blanc char  = space
     k--;
    }
   LCD_puts(CRam1);
   UART1_Write_CText("indice ");
   WordToStr(j,txt);
   UART1_Write_Text(txt); UART1_Write(TAB);
   UART1_Write_CText("ADC= ");
   WordToStr(EA3,txt);
   UART1_Write_Text(txt); UART1_Write(TAB);
   UART1_Write_CText("Volt= ");
   // txt=Float2Ascii (f1,CRam1,3);
    UART1_Write_Text(CRam1);
    CRLF();
   
   Tempo_XmS(500);
   j++;
    }
  while(1);
 }
  while(1);
 }
 /*
 

11:47:22.281> Mikroc pro 6.50, Test LCD4x20 I2C 16F1847 Version: 150427
11:47:22.406> 16F1847_LCD4x20__I2C_ADC_UART.c
11:47:22.531> Init ADC RA3 pin2 as Analog input

11:47:25.781> ADC=     0
11:47:25.781> ADC=     3
11:47:25.781> ADC=     6
11:47:25.843> ADC=    11
11:47:25.906> ADC=    20
11:47:25.968> ADC=    28
11:47:26.031> ADC=    28
11:47:26.093> ADC=    28
11:47:26.156> ADC=    28
11:47:26.218> ADC=    28
11:47:26.281> ADC=    28
11:47:26.406> ADC=    36
11:47:26.468> ADC=    44
11:47:26.593> ADC=    54
11:47:26.718> ADC=    63
11:47:26.906> ADC=    74
11:47:27.093> ADC=    85
11:47:27.281> ADC=    95
11:47:27.531> ADC=   104
11:47:27.781> ADC=   115
11:47:28.031> ADC=   128
11:47:28.281> ADC=   139
11:47:28.656> ADC=   151
11:47:28.968> ADC=   159
11:47:29.281> ADC=   163
11:47:29.656> ADC=   173
11:47:30.031> ADC=   180
11:47:30.406> ADC=   184
11:47:30.781> ADC=   187
11:47:31.218> ADC=   188
11:47:31.593> ADC=   194
11:47:32.031> ADC=   205
11:47:32.468> ADC=   222
11:47:32.968> ADC=   242
11:47:33.468> ADC=   255


Mikroc pro 6.50, Test LCD4x20 I2C 16F1847 Version: 150425
16F1847_LCD4x20__I2C_ADC_UART.c
Init ADC RA3 pin2 as Analog input
indice     0	ADC=     0	Volt= 0.000
indice     1	ADC=     0	Volt= 0.000
indice     2	ADC=     0	Volt= 0.000
indice     3	ADC=   153	Volt= 0.747
indice     4	ADC=   276	Volt= 1.348
indice     5	ADC=   444	Volt= 2.168
indice     6	ADC=   577	Volt= 2.817
indice     7	ADC=   678	Volt= 3.311
indice     8	ADC=   684	Volt= 3.340
indice     9	ADC=   821	Volt= 4.009
indice    10	ADC=   942	Volt= 4.600
indice    11	ADC=  1023	Volt= 4.995
indice    12	ADC=  1023	Volt= 4.995
indice    13	ADC=  1023	Volt= 4.995
indice    14	ADC=   636	Volt= 3.105
indice    15	ADC=   473	Volt= 2.310
indice    16	ADC=   417	Volt= 2.036
indice    17	ADC=    81	Volt= 0.396
indice    18	ADC=     0	Volt= 0.000
indice    19	ADC=     0	Volt= 0.000


fichier resultant de la compilation   copier dans editeur de TEXTE  Notepad++
faire Remplacer 
           "__Lib"
       par ^C"__Lib"
       pour rajouter un saut de ligne  chaque definition de LIB
_LCD_I2C.c"
"__Lib_Math.mcl"
"__Lib_MathDouble.mcl"
"__Lib_System.mcl"
"__Lib_Delays.mcl"
"__Lib_CType.mcl"
"__Lib_CString.mcl"
"__Lib_CStdlib.mcl"
"__Lib_Conversions.mcl"
"__Lib_ADC.mcl"
"__Lib_EEPROM.mcl"
"__Lib_I2C_b14.mcl"
"__Lib_UART_b21.mcl"

0 1 mikroCPIC1618.exe -MSF -DBG -pP16F1847 -RA -C -O00001114 -fo8 -N"C:\_MikroC\_MesProjets_MikroC\_16F1847_LCD_I2C\16F1847_LCD_I2C.mcppi" -EH"C:\_MikroC\_MesProjets_MikroC\_16F1847_LCD_I2C\16F1847_LCD_I2C_EEprom.ihex" -SP"C:\_MikroC\mikroC PRO for PIC\defs\" -SP"C:\_MikroC\mikroC PRO for PIC\Uses\P16_Enh\" -SP"C:\_MikroC\_MesProjets_MikroC\_16F1847_LCD_I2C\" -SP"C:\_MikroC\_MesProjets_MikroC\common\" -IP"C:\_MikroC\_MesProjets_MikroC\_16F1847_LCD_I2C\" -IP"C:\_MikroC\_MesProjets_MikroC\common\" "16F1847_LCD_I2C.c" "__Lib_Math.mcl" "__Lib_MathDouble.mcl" "__Lib_System.mcl" "__Lib_Delays.mcl" "__Lib_CType.mcl" "__Lib_CString.mcl" "__Lib_CStdlib.mcl" "__Lib_Conversions.mcl" "__Lib_ADC.mcl" "__Lib_EEPROM.mcl" "__Lib_I2C_b14.mcl" "__Lib_UART_b21.mcl"
0 1139 Available RAM: 1008 [bytes], Available ROM: 8192 [bytes]
0 122 Compilation Started P16F1847.c
1400 123 Compiled Successfully P16F1847.c
0 122 Compilation Started __Lib_Delays.c
123 123 Compiled Successfully __Lib_Delays.c
49 1354  warning: The macro is redefined     #define PROCESSOR 16F1827     previously macro "PROCESSOR" defined as: #define PROCESSOR  16F1847  C:\_MikroC\_MesProjets_MikroC\_16F1847_LCD_I2C\16F1847_LCD_I2C.c
0 122 Compilation Started lib_lcd_i2c.h
37 1504 Initialization of extern object 'mesg0' lib_lcd_i2c.h
143 1163 Variable 'adpt' has been declared, but not used 16F1847_LCD_I2C.c
233 1509 Generated baud rate is 9615 bps (error = 0.16 percent) 16F1847_LCD_I2C.c
328 123 Compiled Successfully 16F1847_LCD_I2C.c
68 1164 Variable 'dummy' has been eliminated by optimizer 16F1847_LCD_I2C.c
0 127 All files Compiled in 47 ms
0 1144 Used RAM (bytes): 169 (17%)  Free RAM (bytes): 839 (83%) Used RAM (bytes): 169 (17%)  Free RAM (bytes): 839 (83%)
0 1144 Used ROM (program words): 3013 (37%)  Free ROM (program words): 5179 (63%) Used ROM (program words): 3013 (37%)  Free ROM (program words): 5179 (63%)
0 125 Project Linked Successfully 16F1847_LCD_I2C.mcppi
0 128 Linked in 31 ms
0 129 Project '16F1847_LCD_I2C.mcppi' completed: 156 ms
0 103 Finished successfully: 27 avr. 2015, 11:38:12 16F1847_LCD_I2C.mcppi

*/