#line 1 "C:/_MikroC/_MesProjets_MikroC/_16F1847_LCD_I2C/16F1847_LCD_I2C.c"
#line 1 "c:/_mikroc/mikroc pro for pic/include/built_in.h"
#line 1 "c:/_mikroc/_mesprojets_mikroc/_16f1847_lcd_i2c/lib_lcd_i2c.h"
#line 1 "c:/_mikroc/mikroc pro for pic/include/built_in.h"
#line 37 "c:/_mikroc/_mesprojets_mikroc/_16f1847_lcd_i2c/lib_lcd_i2c.h"
extern const code char mesg0[]="                   ";
extern int Etat;
extern unsigned char * txt;
extern unsigned int addr;

extern void strConstRamCpy(unsigned char *dest, const code char *source);
extern void CRLF(void) ;

unsigned char I2C_PCF8574_Write(unsigned char Adr,unsigned char value);
void LCD_init_4x20(void);
void LCD_putcmd(unsigned char d,unsigned char cmdtype);
void LCD_putch(unsigned char d);
void LCD_puts(char *s);
void LCD_putsRom(code char *s);



void LCD_Msg_Status(const char* T);
void LCD_Write_CText(const char *txt) ;
void LCDHandler(char c);
#line 66 "c:/_mikroc/_mesprojets_mikroc/_16f1847_lcd_i2c/lib_lcd_i2c.h"
 unsigned char I2C_PCF8574_Write(unsigned char Adr,unsigned char value)
{
 unsigned char S,dummy;
 I2C1_Start();
 S = I2C1_Wr( Adr );
 if(S == -1)
 {
 dummy = SSPBUF;
 SSPCON1.WCOL=0;
 }
S = I2C1_Wr(value);
I2C1_Stop();
return(S);
}

void Erase_Line(int L)
{
switch(L)
 {
 case 1:
 {
 LCD_putcmd( 0x80 ,1);
 LCD_Write_CText(mesg0);
 LCD_putcmd( 0x80 ,1);
 break;
 }
 case 2:
 {
 LCD_putcmd( 0xC0 ,1);
 LCD_Write_CText(mesg0);
 LCD_putcmd( 0xC0 ,1);
 break;
 }
 case 3:
 {
 LCD_putcmd( 0x94 ,1);
 LCD_Write_CText(mesg0);
 LCD_putcmd( 0x94 ,1);
 break;
 }
 case 4 :
 {
 LCD_putcmd( 0xD4 ,1);
 LCD_Write_CText(mesg0);
 LCD_putcmd( 0xD4 ,1);
 break;
 }
 }
}


void LCD_putcmd(unsigned char d,unsigned char cmdtype)
{
 unsigned char lcddata;

 lcddata = (d & 0xF0)| 0x08 ;
 Etat=I2C_PCF8574_Write(addr,lcddata |  0x04 );
 Delay_us(10);

 Etat=I2C_PCF8574_Write(addr,lcddata & ~ 0x04 );
 Delay_us(10);

 if (cmdtype) {

 lcddata = ((d << 4) & 0xF0)| 0x08 ;
 Etat=I2C_PCF8574_Write(addr,lcddata |  0x04 );
 Delay_us(2);

 Etat=I2C_PCF8574_Write(addr,lcddata & ~ 0x04 );
 Delay_ms(5);
 }
}

void LCD_putch(unsigned char d)
{
 unsigned char lcddata;

 lcddata = (d & 0xF0)| 0x08 | 0x01 ;
 Etat=I2C_PCF8574_Write(addr,lcddata |  0x04 );
 Delay_us(5);

 Etat=I2C_PCF8574_Write(addr,lcddata & ~ 0x04 );
 Delay_us(5);

 lcddata = ((d << 4) & 0xF0)| 0x08 | 0x01 ;
 Etat=I2C_PCF8574_Write(addr,lcddata |  0x04 );
 Delay_us(5);

 Etat=I2C_PCF8574_Write(addr,lcddata & ~ 0x04 );
 Delay_us(5);
}

void LCD_init_4x20(void)
{
 addr= 0x4E ;

 Delay_ms(1500);

 LCD_putcmd(0x30,0);

 Delay_ms(50);

 LCD_putcmd(0x30,0);

 Delay_ms(20);

 LCD_putcmd(0x30,0);
 Delay_ms(20);

 LCD_putcmd(0x20,0);
 Delay_ms(20);

 LCD_putcmd(0x28,1);
 Delay_ms(20);

 LCD_putcmd(0x08,1);
 Delay_ms(20);

 LCD_putcmd( 0x01 ,1);
 Delay_ms(100);

 LCD_putcmd(0x06,1);
 Delay_ms(20);

 LCD_putcmd(0x0C,1);
 Delay_ms(20);
}

void LCD_putsRom(const code char *s)
{int i=0;
 while((*s != 0)&& (i<20))
 {
 LCD_putch(*s);
 s++;i++;
 }
}

void LCD_puts( char *s)
{int i=0;
 while((*s != 0)&& (i<20))
 {
 LCD_putch(*s);
 s++; i++;
 }
}

void LCD_Write_CText(const char *txt)
{
 while (*txt)
 LCD_putch(*txt++);
 }

void LCDHandler(char c) {
 LCD_putch(c);
}


 void LCD_Msg_Status(const char* T)
{

 LCD_putcmd( 0xD4 ,1);
 strConstRamCpy(txt,T);

 LCD_puts(txt);
}
#line 1 "c:/_mikroc/_mesprojets_mikroc/_16f1847_lcd_i2c/delays.h"
#line 50 "c:/_mikroc/_mesprojets_mikroc/_16f1847_lcd_i2c/delays.h"
extern void DelayMs(unsigned char);
extern void DelaySec(char sec);
void Tempo_1mS(void);
void Tempo_XmS(unsigned int x);

unsigned char N1;


void Tempo_XmS(unsigned int t)
{
 unsigned int t1;
 t1=t;
 while(t1>0)
 {
 Tempo_1mS();
 t1--;
 }
}


void Tempo_1mS()
{
asm{
 MOVLW 210 ;
 MOVWF _N1;
 ici:
 nop ;
 nop ;
 nop ;
 nop ;
 nop ;
 nop ;
 nop ;
 nop ;
 nop ;
 nop ;
 nop ;
 nop ;
 nop ;
 nop ;
 nop ;
 nop ;
 decfsz _N1 ,F ;
 bra ici ;
 nop;
 nop;
 nop;
 nop;
 } ;
 }
#line 84 "C:/_MikroC/_MesProjets_MikroC/_16F1847_LCD_I2C/16F1847_LCD_I2C.c"
sbit Led_Rouge at LATA4_bit;

const code char mesg0[]="                   ";
const code char mesg1[]="Mikroc pro 6.50, Test LCD4x20 I2C 16F1847 Version: " "150428" " \n\r";
const code char * Messages[]={mesg0,mesg1};



unsigned char TEXTE[80];
int i,j,k,l;
unsigned int EA1,EA2,EA3;
unsigned char * txt;
char CRam1[20];

int Etat;
int addr;
float f1;

void Read_Msg_Eeprom(unsigned char depuis);
void Init_Hardware(void);
void Float2Ascii (float x, unsigned char *str,char precision);
void CRLF(void);
void UART1_Write_CText(const char *txt);


void Init_Hardware(void) ;
#line 119 "C:/_MikroC/_MesProjets_MikroC/_16F1847_LCD_I2C/16F1847_LCD_I2C.c"
void Init_Hardware()
{
 ANSELA=0;
 TRISA=0xFF;

 TRISA.LATA4=0;
 ANSELA.F3=1;

 ANSELB = 0xFF;
 PORTB = 0xFF;
 TRISB = 0x00;

 CM1CON0=0;
 CM1CON1=0;

 TRISB.TRISB1 = 1;
 TRISB.TRISB4 = 1;
 }


void Float2Ascii (float x, unsigned char *str,char precision)
{


 unsigned char *adpt;
 int ie, i, k, ndig;
 double y;
 ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
 ie = 0;

 if ( x < 0)
 {
 *str++ = '-';
 x = -x;
 }

 if (x > 0.0) while (x < 1.0)
 {
 x *= 10.0;
 ie--;
 }
 while (x >= 10.0)
 {
 x = x/10.0;
 ie++;
 }

 ndig += ie;


 for (y = i = 1; i < ndig; i++)
 y = y/10.;
 x += y/2.;
 if (x >= 10.0) {x = 1.0; ie++;}
 if (ie<0)
 {
 *str++ = '0'; *str++ = '.';
 if (ndig < 0) ie = ie-ndig;
 for (i = -1; i > ie; i--) *str++ = '0';
 }
 for (i=0; i < ndig; i++)
 {
 k = x;
 *str++ = k + '0';
 if (i == ie ) *str++ = '.';
 x -= (y=k);
 x *= 10.0;
 }
 *str = '\0';
}

void CRLF()
{
 UART1_Write( 13 );
 UART1_Write( 10 );
}


void UART1_Write_CText(const char *txt) {
 while (*txt)
 UART1_Write(*txt++);
}


void Read_Msg_Eeprom(unsigned char debut)
{ int i1 ,i;
 i1=debut;
 do
 {
 i = EEPROM_Read(i1);
 if ( i==0) break;
 if ( i1>254) break;
 UART1_Write(i);
 Delay_ms(5);
 i1++;
 }
 while (i!=0) ;
 }

void main()
 {

 OSCCON =0;
 OSCCON.IRCF3=1;
 OSCCON.IRCF2=1;
 OSCCON.IRCF1=1;
 OSCCON.IRCF0=0;
 OSCCON.SCS1=1;

 Init_Hardware() ;

 txt=TEXTE;

 APFCON1.TXCKSEL=0;
 UART1_Init(9600);
 UART1_Write( 12 );
 Tempo_XmS(500);
 UART1_Write_CText(mesg1);
 Read_Msg_Eeprom(0);
 CRLF();

 ADC_Init();
 Tempo_XmS(100);
 UART1_Write_CText("Init ADC RA3 pin2 as Analog input\r\n");
 j=0;


 ADCON0 =0;


 ADCON1 = 0;

 ADCON1.ADFM=1;
 ADCON1.ADCS2=1;
 ADCON1.ADCS1=0;
 ADCON1.ADCS0=1;
 ADCON1.ADNREF=0;
 ADCON1.ADPREF1=0;
 ADCON1.ADPREF0=0;

 ADCON0.CHS4=0;
 ADCON0.CHS3=0;
 ADCON0.CHS2=0;
 ADCON0.CHS1=1;
 ADCON0.CHS0=1;
 ADCON0.ADON=1;
#line 285 "C:/_MikroC/_MesProjets_MikroC/_16F1847_LCD_I2C/16F1847_LCD_I2C.c"
 I2C1_Init(400000);
 do
 {

 addr= 0x4E ;
 LCD_init_4x20();
 LCD_putcmd( 0x01 ,1);
 LCD_putcmd( 0x80 ,1); Delay_ms(25);
 LCD_putsRom((const code unsigned char *)"16F1847 8MHz MikroC ");
 LCD_putcmd( 0xC0 ,1); Delay_ms(25);
 LCD_putsRom((const code unsigned char *)"Test library LCD I2C");
 LCD_putcmd( 0x94 ,1); Delay_ms(25);
 LCD_putsRom((const code unsigned char *)"version:"  "150428" );
 Tempo_XmS(500);
 do
 {
 LCD_putcmd( 0xD4 ,1); Delay_ms(25);
 EA3=ADC_Get_Sample(3);
 WordToStr(EA3,txt);
 LCD_puts(txt);
 f1= (float) EA3 * 0.0048828;
 Float2Ascii (f1,CRam1,3);
 k=10-strlen(CRam1);
 LCD_putcmd( 0xD4 +10,1);Delay_ms(25);

 while(k>0)
 {
 LCD_putch(32);
 k--;
 }
 LCD_puts(CRam1);
 UART1_Write_CText("indice ");
 WordToStr(j,txt);
 UART1_Write_Text(txt); UART1_Write( 9 );
 UART1_Write_CText("ADC= ");
 WordToStr(EA3,txt);
 UART1_Write_Text(txt); UART1_Write( 9 );
 UART1_Write_CText("Volt= ");

 UART1_Write_Text(CRam1);
 CRLF();

 Tempo_XmS(500);
 j++;
 }
 while(1);
 }
 while(1);
 }
